Package: org.codehaus.groovy.groovydoc

## [Java] Interface GroovyRootDoc

- org.codehaus.groovy.groovydoc.GroovyDocErrorReporter

- All Superinterfaces:
    GroovyDoc, GroovyDocErrorReporter

      public interface GroovyRootDoc
      extends GroovyDoc, GroovyDocErrorReporter

  Root object for a Groovydoc run, exposing the discovered packages, classes, and diagnostics APIs.

- - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public GroovyClassDoc` | `classNamed(GroovyClassDoc groovyClassDoc, String name)` Resolves a class name from the perspective of another documented class.
    `` | `public GroovyClassDoc[]` | `classes()` Returns all classes known to this documentation run.
    `` | `public Map<String, GroovyClassDoc>` | `getResolvedClasses()` Returns the classes that have already been resolved for the current documentation run.
    `` | `public Map<String, GroovyClassDoc>` | `getVisibleClasses(List importedClassesAndPackages)` Returns the classes visible from a set of imports.
    `` | `public String[]` | `options()` Returns the effective tool options associated with this documentation run.
    `` | `public GroovyPackageDoc` | `packageNamed(String arg0)` Resolves a package by name.
    `` | `public GroovyClassDoc[]` | `specifiedClasses()` Returns the classes explicitly specified as documentation targets.
    `` | `public GroovyPackageDoc[]` | `specifiedPackages()` Returns the packages explicitly specified as documentation targets.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `interface GroovyDoc` | `commentText, firstSentenceCommentText, getRawCommentText, isAnnotationType, isAnnotationTypeElement, isClass, isConstructor, isDeprecated, isEnum, isEnumConstant, isError, isException, isField, isIncluded, isInterface, isMethod, isOrdinaryClass, isRecord, name, setRawCommentText`
    `interface GroovyDocErrorReporter` | `printError, printNotice, printWarning`

- - ### Method Detail

    - #### public GroovyClassDoc classNamed(GroovyClassDoc groovyClassDoc, String name)

      Resolves a class name from the perspective of another documented class.

      Parameters:
        `groovyClassDoc` - the class providing the lookup context
        `name` - the class name to resolve
      Returns:
        the matching class documentation, or `null` if it cannot be resolved

    - #### public GroovyClassDoc[] classes()

      Returns all classes known to this documentation run.

      Returns:
        the discovered classes

    - #### public Map<String, GroovyClassDoc> getResolvedClasses()

      Returns the classes that have already been resolved for the current documentation run.

      Returns:
        a map of resolved class names to class documentation

    - #### public Map<String, GroovyClassDoc> getVisibleClasses(List importedClassesAndPackages)

      Returns the classes visible from a set of imports.

      Parameters:
        `importedClassesAndPackages` - the imported classes and packages to evaluate
      Returns:
        a map of visible class names to class documentation

    - #### public String[] options()

      Returns the effective tool options associated with this documentation run.

      Returns:
        the configured options

    - #### public GroovyPackageDoc packageNamed(String arg0)

      Resolves a package by name.

      Parameters:
        `arg0` - the package name to resolve
      Returns:
        the matching package documentation, or `null` if none exists

    - #### public GroovyClassDoc[] specifiedClasses()

      Returns the classes explicitly specified as documentation targets.

      Returns:
        the specified classes

    - #### public GroovyPackageDoc[] specifiedPackages()

      Returns the packages explicitly specified as documentation targets.

      Returns:
        the specified packages